### Sub-options 4,5: Global tests across loci or across samples
For sub-option 3, a global test across loci or across sample is constructed using Fisher’s method.\index{Combination of different tests} This method (sometimes conservative because discrete probabilities are analyzed), is only performed for convenience and its relevance should be first established (e.g. statistical independence of loci).

General statistical theory shows that there is no uniformly better way to combine $P$-values of different tests. When an alternative model is specified, it is possible to find a better way of combining results from different data sets than Fisher’s method, and usually not by combining $P$-values. In the present context one such method is the multisample score test\index{Hardy-Wein\-berg Tests!multisample score test} of @RoussetR95, which defines a global test across loci and/or across samples generalizing the tests of sub-options 1 and 2. The global tests are performed by sub-options 4 and 5, only by the MC algorithm. Independence of loci is also assumed for these global tests.

The output file reports global P value estimates and standard errors per population, per locus, and over all loci and populations. For each global P value, the average number of switches per test combined is also reported. Since it is tempting to reduce the chain length parameters in this option, special care is needed in checking this accuracy diagnostic (see p.41).[^12]

This option generates several large temporary files. The space used temporarily by Genepop can be estimated as: (\#of Loci+\#of pop+1)\*batches\*(iterations per batch)\*8 octets. For example it will require about 240 Mo of temporary hard disk space if you have 10 loci, 50 samples and if you use a chain of 500,000 steps (100 batches of 5000 iterations).
