### Sub-options 1–4: $F$-statistics and $\rho$-statistics
These options compute estimates of $F_\mathrm{IS}$, $F_\mathrm{IT}$ and $F_\mathrm{ST}$ or analogous correlations for allele size, either for each pair of population (sub-options 2 and 4) or a single measure for all populations (sub-options 1 and 3). $F_\mathrm{ST}$ is estimated by a “weighted” analysis of variance @Cockerham73 [@WeirC84], and the analogous measure of correlation in allele size ($\rho_\mathrm{ST}$) is estimated by the same technique (see Section \@ref(rho-stats)). Multilocus estimates are computed as detailed in Section \@ref(Fmulti)). For haploid data,\index{Haploid data} remember to use the `EstimationPloidy=Haploid` setting.

In sub-option 1, the output is saved in the file *yourdata*`.FST`. Beyond $F_\mathrm{IS}$, $F_\mathrm{IT}$ and $F_\mathrm{ST}$ estimates, estimation of within-individual gene diversity and within-population among-individual gene diversity are reported as in option 5.2.

In sub-option 2 (pairs of populations), single locus and multilocus estimates are written in the *yourdata*`.ST2` file and multilocus estimates are also written in the *yourdata*`.MIG` file in a format suitable for analysis of isolation by distance (see option 6.6 for further details).

Sub-option 3 is analogous to sub-option 1, but for allele-size based estimates. the output is saved in the file *yourdata*`.RHO`. Beyond $\rho_\mathrm{IS}$, $\rho_\mathrm{IT}$ and $\rho_\mathrm{ST}$ estimates, estimation of within-individual gene diversity and within-population among-individual gene diversity are reported as in option 5.3.

Sub-option 4 is analogous to sub-option 2, but for allele-size based estimates. Output file names are as in sub-option 2.
